SUBROUTINE sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,&
	init_delta_shock,init_clunk_shock,age_t,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,q_t_shock,rk_t_shock, &
	v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock,&
	idcross_m,ixcross_m,ideltacross_m)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng,ndp,nc,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,nc,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(shocklives,agents,rep), INTENT(IN) :: &
	 init_y_shock, init_x_shock, init_d_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(IN) :: init_d_nadj_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(IN) :: init_delta_shock
  INTEGER, DIMENSION(agents,rep), INTENT(IN) :: init_clunk_shock
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(IN) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(IN) :: &
	n_shck_shock, u_shck_shock, dp_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(IN) :: p_t_shock
  REAL(8), DIMENSION(numshock,ng,rep,shck_c), INTENT(IN) :: q_t_shock, w_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(IN) :: rk_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(IN) :: v_shck_shock, &
	 m_shck_shock
  INTEGER, DIMENSION(numshock,shck_c), INTENT(IN) :: g_shck_shock
  REAL(8), DIMENSION(agents,rep), INTENT(OUT) :: idcross_m, ixcross_m
  INTEGER, DIMENSION(agents,rep), INTENT(OUT) :: ideltacross_m

  INTEGER :: time, time_i, i, j, k, o, yr_index
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	ibpcross, iycross, iynoadjcross, iwcross, imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ivalnewcar, ivalnewcar_byp, &
	iapcross_max, idpcross_max, isavecross, isavecross_r, iinccross, &
	id_ccross,  ix_realcross, iq_tcross, idisccross, isubcross
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, isavshare, ideltacross, &
	iclunkcross,  iclunkbuycross, iclunkreccross

  INTEGER, DIMENSION(agents) :: inewcar_clunk
  REAL(8), DIMENSION(agents) :: ivalnewcar_clunk

  REAL(8), DIMENSION(numshock,rep,shck_c) :: cts, dts, its, iexts, newcar, valnewcar, valnewcar_byp, kts, &
	bts, mts, yts, ynoadjts, wts, sav, passet, inc, xts, agets

  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp
  INTEGER :: AllocateStatus

  k=1
  rep1: DO j = 1, rep
  time1: DO time = 1, numshock-1


  !$OMP PARALLEL
  !$OMP DO PRIVATE(u_temp)
   DO i = 1, agents
   IF (time==1) THEN
     IF (age_t(1,i)<=twork) THEN
     u_temp = u_shck_shock(1,i,j)*m_shck_shock(1,age_t(1,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( init_x_shock(1,i,j) >= 0.d0 ) THEN
	    ikcross(i) = init_x_shock(1,i,j) /r
	    imcross(i) = init_x_shock(1,i,j) / (r*q_t_shock(1,age_t(1,i),j,k))
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(1,i,j) )/(r+rk_t_shock(1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF
   ideltacross(i) = init_delta_shock(1,i,j)
   idcross(i) = init_d_shock(1,i,j)/p_t_shock(1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x_shock(1,i,j) /p_t_shock(1,i,j,k) &
	 + (1.d0-delta(ideltacross(i)) )*idcross(i) + u_temp

   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   init_loc(i) = 2

   IF (init_d_nadj_shock(1,i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), nc, g_shck_shock(1,k), rk_t_shock(1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)) )*idcross(i)-u_temp) &
	/(r+rk_t_shock(1,j,k))<-eta*idcross(i) ) THEN
     ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk_t_shock(1,j,k)))*idcross(i) + u_temp
     END IF
   END IF

   inewcar_clunk(i) = 0.d0
   ivalnewcar_clunk(i) = 0.d0
   idisccross(i) = 0.d0
   isubcross(i) = 0.d0
   iclunkbuycross(i) = 0
   iclunkreccross(i) = 0

   END IF

   IF(time==clunk_ex_bg .AND. k==1) THEN
     idcross_m(i,j) = MIN( idcross(i) / scale_y, Dmax_m )
     ideltacross_m(i,j) = ideltacross(i)
     IF (age_t(time,i)<=twork) THEN
     ixcross_m(i,j) = (ixcross(i)-u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k) ) / scale_y
     ELSE
     ixcross_m(i,j) = (ixcross(i)-u_ret) / scale_y
     END IF
   END IF

   IF (time==numshock-clunk_period .AND. k .LT. shck_c) THEN
     IF (age_t(time,i)<=twork) THEN
     u_temp = u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( p_t_shock(time,i,j,k) * u_temp .LE. clunk_inc)THEN
     iclunkcross(i) = init_clunk_shock(i,j)
     ELSE
     iclunkcross(i) = nc
     END IF
   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), &
	 iclunkcross(i), g_shck_shock(time,k), rk_t_shock(time,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   ELSE
   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), &
	 nc, g_shck_shock(time,k), rk_t_shock(time,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   END IF

   IF (alive_t_shock(time,i,j)==1) THEN
     ic_realcross(i) = iccross(i) * p_t_shock(time,i,j,k)
     id_realcross(i) = idcross(i) * p_t_shock(time,i,j,k)
     IF (iccross(i) .GT. 0.d0 ) THEN
     id_ccross(i) = idpcross(i) / iccross(i)
     END IF
     IF (age_t(time,i)<=twork) THEN
     u_temp = u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     ix_realcross(i) = (ixcross(i)-u_temp) * p_t_shock(time,i,j,k)

     IF (time==numshock-clunk_period .AND. k .LT. shck_c .AND. idpcross(i) .LE. clunk_thr) THEN
     iicross(i) = (idpcross(i)*clunk(iclunkcross(i)) - (1.d0-delta(ideltacross(i)) )*idcross(i)) * p_t_shock(time,i,j,k)
     ELSE
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)) )*idcross(i)) * p_t_shock(time,i,j,k)
     END IF
       IF (adjcross(i)==2 .AND. &
		idpcross(i) > (1.d0-delta(ideltacross(i)) )*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i)  - idcross(i)) * p_t_shock(time,i,j,k)
        IF ( (time==numshock-clunk_period) .AND. (iclunkcross(i)==1) .AND. &
		(k .LT. shck_c) .AND. (idpcross(i) .LE. clunk_thr) ) THEN
        iclunkreccross(i) = 1
          IF ( idpcross(i)*clunk(1) .GT. idcross(i) ) THEN
          ivalnewcar_byp(i) = (idpcross(i)*clunk(1) - idcross(i)) * p_t_shock(time,i,j,k)
          idisccross(i) = ( 1.d0-clunk(1) ) * idpcross(i) / (idpcross(i)  - idcross(i))
          iclunkbuycross(i) = 1
          ELSE
          ivalnewcar_byp(i) = 0.000001d0
          END IF
        ELSE
        ivalnewcar_byp(i) =  ivalnewcar(i)
        END IF
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       END IF

       IF (adjcross(i)==2) THEN
       ideltacross(i) = 2
          IF (time==numshock-clunk_period .AND. k .LT. shck_c .AND. idpcross(i) .LE. clunk_thr) THEN
          isubcross(i) = ( 1.d0-clunk(1) ) * idpcross(i) * p_t_shock(time,i,j,k)
          END IF
       ELSE
         IF ( dp_shck_shock(time,i,j) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF

       IF (age_t(time,i)<=twork) THEN
       u_temp = u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
       ELSE
       u_temp =  u_ret
       END IF

       IF (time==numshock-clunk_period .OR. time==numshock-clunk_period+1) THEN
       inewcar_clunk(i) = inewcar_clunk(i) + inewcar(i)
       ivalnewcar_clunk(i) = ivalnewcar_clunk(i) + ivalnewcar(i)
       END IF

       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       impcross(i) = ikpcross(i)/q_t_shock(time,age_t(time,i),j,k)
       ibpcross(i) = 0.d0
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       END IF
    IF (ikcross(i) .GE. 0) THEN
    iinccross(i) = p_t_shock(time,i,j,k)*u_temp + (r-1.d0)*q_t_shock(time,age_t(time,i),j,k)*imcross(i)
    isavecross(i) = iinccross(i) - iicross(i) - iadjcross(i) - ic_realcross(i)
    ELSE
    iinccross(i) = p_t_shock(time,i,j,k)*u_temp
    isavecross(i) = iinccross(i) - (r+rk_t_shock(time+1,j,k)-1.d0)*ibcross(i) &
	 - iicross(i) - iadjcross(i) - ic_realcross(i)
    END IF


       IF(age_t(time,i)<=twork) THEN
       iwork(i) = 1
       iwcross(i) = p_t_shock(time,i,j,k)*u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
       ELSE
       iwork(i) = 0
       iwcross(i)=0.d0
       END IF

    IF (time==numshock-clunk_period+1) THEN
      IF (inewcar_clunk(i) .GT. 0.d0) THEN
      inewcar_clunk(i) = 1.d0
      END IF
    END IF

   ELSE
   ic_realcross(i)=0.d0
   id_realcross(i)=0.d0
   id_ccross(i) = 0.d0
   ix_realcross(i)=0.d0
   iicross(i)=0.d0
   iadjcross(i)=0.d0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
   ivalnewcar_byp(i)=0.d0
   ikcross(i)=0.d0
   ikpcross(i) = 0.d0
   ibcross(i)=0.d0
   imcross(i)=0.d0
   iinccross(i) = 0.d0
   isavecross(i) = 0.d0
   iwork(i)=0
   iwcross(i)=0.d0
   END IF


   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  cts(time,j,k)   = SUM( ic_realcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  dts(time,j,k) = SUM( id_realcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  xts(time,j,k) = SUM( ix_realcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  its(time,j,k)   = SUM( iicross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  iexts(time,j,k) = SUM( ivalnewcar_byp ) / SUM(DBLE(alive_t_shock(time,:,j)))
  newcar(time,j,k) = SUM( DBLE(inewcar) )/ SUM(DBLE(alive_t_shock(time,:,j)))
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time,j,k) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  valnewcar_byp(time,j,k) = SUM( ivalnewcar_byp ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time,j,k) = 0.d0
  valnewcar_byp(time,j,k) = 0.d0
  END IF
  kts(time,j,k) = SUM( ikcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  bts(time,j,k) = SUM( ibcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  mts(time,j,k) = SUM( imcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  wts(time,j,k)   = SUM(iwcross ) / SUM( DBLE(iwork) )
  sav(time,j,k)   = SUM( isavecross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  inc(time,j,k)   = SUM( iinccross ) / SUM(DBLE(alive_t_shock(time,:,j)))

  ! Update states
  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)) )*idcross(i) + &
		u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     ELSE
     ixcross(i) = (r+rk_t_shock(time+1,j,k))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)) )*idcross(i) + &
		u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i),g_shck_shock(time+1,k))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		gnodes(age_t(time+1,i),g_shck_shock(time+1,k)) + &
		(1.d0-delta(ideltacross(i)) )*idcross(i)  + u_ret
     ELSE
     ixcross(i) = ( r+rk_t_shock(time+1,j,k) )*( iapcross(i)-eta*idpcross(i) ) / &
		  gnodes(age_t(time+1,i),g_shck_shock(time+1,k)) + &
		  (1.d0-delta(ideltacross(i)) )*idcross(i)  +  u_ret
     END IF

     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)

   ELSE
     IF ( init_x_shock(init_loc(i),i,j) >= 0.d0 ) THEN
		 ikcross(i) = init_x_shock(init_loc(i),i,j) /r
		 imcross(i) = init_x_shock(init_loc(i),i,j) / ( r*q_t_shock(time+1,1,j,k) )
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(init_loc(i),i,j) )/(r+rk_t_shock(time+1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF

   ideltacross(i) = init_delta_shock(init_loc(i),i,j)
   idcross(i) =  init_d_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k) + &
		(1.d0-delta(ideltacross(i)) )*idcross(i) + &
		u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)

   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   IF (init_d_nadj_shock(init_loc(i),i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), nc, g_shck_shock(time+1,k), rk_t_shock(time+1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)) )*idcross(i)-&
	u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k) )/ &
		(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = (1.d0-delta(ideltacross(i)) -eta*(r+rk))*idcross(i) +&
	u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
   END IF
   init_loc(i) = init_loc(i)+1

   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END DO time1


  END DO rep1

  yr_index = clunk_ex_bg+yr_pr-1


END SUBROUTINE sub_shocksim
