SUBROUTINE sub_shocksim_mnth(Vnoadjust_m,Vadjust_m,a_adj_m,a_nadj_m,D_adj_m, &
	ixcross_m,idcross_m,ideltacross_m,init_x_shock_m,init_d_shock_m,&
	init_d_nadj_shock_m,init_delta_shock_m,init_clunk_shock_m,&
	age_t_m,alive_t_shock_m, n_shck_shock_m,u_shck_shock_m,&
	p_t_shock_m,dp_shck_shock_m,q_t_shock_m,rk_t_shock_m, &
	v_shck_shock_m,m_shck_shock_m,w_shck_shock_m,g_shck_shock_m)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(IN) :: Vnoadjust_m, Vadjust_m
  REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(IN) :: a_adj_m, a_nadj_m,  D_adj_m
  REAL(8), DIMENSION(agents,rep), INTENT(IN) :: ixcross_m, idcross_m, &
	 init_x_shock_m, init_d_shock_m
  INTEGER, DIMENSION(agents,rep), INTENT(IN) :: init_d_nadj_shock_m
  INTEGER, DIMENSION(agents,rep), INTENT(IN) :: ideltacross_m, init_delta_shock_m
  INTEGER, DIMENSION(clunk_dur_m,agents,rep), INTENT(IN) :: init_clunk_shock_m
  INTEGER, DIMENSION(numshock_m,agents), INTENT(IN) :: age_t_m
  INTEGER, DIMENSION(numshock_m,agents,rep), INTENT(IN) :: alive_t_shock_m
  REAL(8), DIMENSION(numshock_m,agents,rep), INTENT(IN) :: &
	n_shck_shock_m, u_shck_shock_m, dp_shck_shock_m
  REAL(8), DIMENSION(numshock_m,agents,rep,shck_c_m), INTENT(IN) :: p_t_shock_m
  REAL(8), DIMENSION(numshock_m,ng_m,rep,shck_c_m), INTENT(IN) :: q_t_shock_m, w_shck_shock_m
  REAL(8), DIMENSION(numshock_m,rep,shck_c_m), INTENT(IN) :: rk_t_shock_m
  REAL(8), DIMENSION(numshock_m,twork*mnth,shck_c_m), INTENT(IN) :: v_shck_shock_m, &
	m_shck_shock_m
  INTEGER, DIMENSION(numshock_m,agents,shck_c_m), INTENT(IN) :: g_shck_shock_m

  INTEGER :: time, time_m, month, i, j, k, l, m, o
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	ibpcross, iycross, iynoadjcross, iwcross, imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ivalnewcar, ivalnewcar_byp, &
	iapcross_max, idpcross_max, isavecross, ix_realcross, iq_tcross, &
	idisccross, isubcross, ii_bypcross
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, isavshare, ideltacross,  &
	iclunkcross
  INTEGER, DIMENSION(agents) ::  iclunkbuycross, iclunkinclvlcross, iclunkexclvlcross, &
	iclunksubsmpcross, iclunkreccross, iclunkthrcross
  REAL(8), DIMENSION(agents,mnth) :: ic_realcross_pnl, ivalnewcar_pnl, ivalnewcar_byp_pnl, &
	iicross_pnl, ii_bypcross_pnl
  INTEGER, DIMENSION(agents,mnth) :: inewcar_pnl
  REAL(8), DIMENSION(agents) :: ic_realcross_an, ivalnewcar_an, ivalnewcar_byp_an, &
	iicross_an, ii_bypcross_an
  INTEGER, DIMENSION(agents) :: inewcar_an

  REAL(8), DIMENSION(numshock_m,rep,ex_m) :: cts, dts, its, its_byp, iexts, &
	iexts_byp, newcar, valnewcar, valnewcar_byp, kts, &
	bts, mts, wts, sav, xts
  REAL(8), DIMENSION(m_years,rep,ex_m) :: cts_an, dts_an, newcar_an, valnewcar_an, valnewcar_byp_an, &
	its_an, its_byp_an, iexts_an,  iexts_byp_an
	INTEGER(8), DIMENSION(clunk_dur_m,agents) :: clunk_treat

  REAL(8) :: u_temp
  INTEGER :: yr_index

  policy1: DO m=1,2
  shck_c1: DO k=1, shck_c_m
  rep1: DO j = 1, rep
  time1: DO time = 1, m_years
  month1: DO month = 1,mnth
  o = (m-1)*shck_c_m + k
  time_m = (time-1)*mnth + month

  !$OMP PARALLEL
  !$OMP DO PRIVATE(u_temp)
   DO i = 1, agents
   IF (time_m==1) THEN
     IF (age_t_m(1,i)<=twork*mnth) THEN
     u_temp = u_shck_shock_m(1,i,j)*m_shck_shock_m(1,age_t_m(1,i),k)
     ELSE
     u_temp =  u_ret
     END IF
     ideltacross(i) = ideltacross_m(i,j)
     IF ( ixcross_m(i,j)-(1.d0-delta_m(ideltacross(i)) )*idcross(i) >= 0.d0 ) THEN
     ikcross(i) = ( ( ixcross_m(i,j)-(1.d0-delta_m(ideltacross(i)) )*idcross(i) )* &
		p_t_shock_m(1,i,j,k) )/r_m
     imcross(i) = ikcross(i) / q_t_shock_m(1,age_t_m(1,i),j,k)
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( ( ixcross_m(i,j)-(1.d0-delta_m(ideltacross(i)) )*idcross(i) )* &
		p_t_shock_m(1,i,j,k) )/(r_m+rk_t_shock_m(1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF
   idcross(i) = idcross_m(i,j)
   ixcross(i) = ixcross_m(i,j) + u_temp

   iclunkcross(i) = nc
	 clunk_treat(:,i) = 0

     DO l=1, clunk_dur_m
     IF (age_t_m(clunk_period_m+l-1,i)<=twork*mnth) THEN
     u_temp = u_shck_shock_m(clunk_period_m+l-1,i,j)* &
	m_shck_shock_m(clunk_period_m+l-1,age_t_m(clunk_period_m+l-1,i),k)
     ELSE
     u_temp =  u_ret
     END IF

		 IF ( p_t_shock_m(clunk_period_m+l-1,i,j,k) * u_temp .LE. clunk_inc_m ) THEN
			 IF (init_clunk_shock_m(l,i,j)==1) THEN
			 clunk_treat(l,i) = 1
			 END IF
		 ELSE
		 END IF

     END DO

   END IF

   IF (  m==1 .AND. (time_m>=clunk_period_m .AND. time_m<=clunk_period_m+clunk_dur_m-1) ) THEN
     IF (clunk_treat(time_m-clunk_period_m+1,i)==1) THEN
     iclunkcross(i) = 1
     ELSE
     iclunkcross(i) = nc
     END IF
   ELSE
   iclunkcross(i) = nc
   END IF

   CALL sub_pollin_mnth(Vnoadjust_m,Vadjust_m,a_adj_m,a_nadj_m,D_adj_m,&
	 ixcross(i), idcross(i), age_t_m(time_m,i),ideltacross(i), &
	 iclunkcross(i), g_shck_shock_m(time_m,i,k), rk_t_shock_m(time_m,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )

   IF (alive_t_shock_m(time_m,i,j)==1) THEN
     ic_realcross(i) = iccross(i) * p_t_shock_m(time_m,i,j,k)
     ic_realcross_pnl(i,month) = ic_realcross(i)
     id_realcross(i) = idcross(i) * p_t_shock_m(time_m,i,j,k)
     IF (age_t_m(time_m,i)<=twork*mnth) THEN
     u_temp = u_shck_shock_m(time_m,i,j)*m_shck_shock_m(time_m,age_t_m(time_m,i),k)
     ELSE
     u_temp =  u_ret
     END IF
     ix_realcross(i) = (ixcross(i)-u_temp) * p_t_shock_m(time_m,i,j,k)
     IF ( m==1 .AND. (time_m>=clunk_period_m .AND. time_m<=clunk_period_m+clunk_dur_m-1) &
		.AND. (idpcross(i) .LE. clunk_thr_m) ) THEN
     iicross(i) = (idpcross(i) - (1.d0-delta_m(ideltacross(i)))*idcross(i)) * p_t_shock_m(time_m,i,j,k)
     ii_bypcross(i) = (idpcross(i)*clunk_m(iclunkcross(i))  - &
	 (1.d0-delta_m(ideltacross(i)))*idcross(i)) * p_t_shock_m(time_m,i,j,k)
     ELSE
     iicross(i) = (idpcross(i) - (1.d0-delta_m(ideltacross(i)))*idcross(i)) * p_t_shock_m(time_m,i,j,k)
     ii_bypcross(i) = iicross(i)
     END IF
     iicross_pnl(i,month) = iicross(i)
     ii_bypcross_pnl(i,month) = ii_bypcross(i)

     IF (adjcross(i)==2 .AND. &
		idpcross(i) > (1.d0-delta_m(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t_shock_m(time_m,i,j,k)
          IF (idpcross(i) .LE. clunk_thr_m ) THEN
          iclunkthrcross(i) = 1
          ELSE
          iclunkthrcross(i) = 0
          END IF
          IF ( (m==1) .AND. (iclunkcross(i)==1) .AND. &
		(time_m>=clunk_period_m) .AND. (time_m<=clunk_period_m+clunk_dur_m-1) &
		.AND. (idpcross(i) .LE. clunk_thr_m) ) THEN
          iclunkreccross(i) = 1
              IF (idpcross(i)*clunk_m(1)  .GT. idcross(i)) THEN
              ivalnewcar_byp(i) = (idpcross(i)*clunk_m(1)  - idcross(i)) * p_t_shock_m(time_m,i,j,k)
              iclunkinclvlcross(i) = 1
              iclunkexclvlcross(i) = 0
              idisccross(i) = ( 1.d0-clunk_m(1) ) * idpcross(i) / (idpcross(i)  - idcross(i))
              ELSE
              ivalnewcar_byp(i) = 0.000001d0
              iclunkinclvlcross(i) = 0
              iclunkexclvlcross(i) = 1
              idisccross(i) = 0.d0
              END IF
          ELSE
          ivalnewcar_byp(i)=ivalnewcar(i)
          iclunkreccross(i) = 0
          iclunkinclvlcross(i) = 0
          iclunkexclvlcross(i) = 0
          idisccross(i) = 0.d0
          END IF
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       iclunkthrcross(i) = 0
       iclunkreccross(i) = 0
       ivalnewcar_byp(i) = 0.d0
       iclunkinclvlcross(i) = 0
       iclunkexclvlcross(i) = 0
       idisccross(i) = 0.d0
       END IF

       inewcar_pnl(i,month) = inewcar(i)
       ivalnewcar_pnl(i,month) = ivalnewcar(i)
       ivalnewcar_byp_pnl(i,month) = ivalnewcar_byp(i)

       IF (adjcross(i)==2) THEN
       iadjcross(i) = F * id_realcross(i)
       ideltacross(i) = 2
         IF ( (m==1) .AND. (iclunkcross(i)==1) .AND. &
		(time_m>=clunk_period_m) .AND. (time_m<=clunk_period_m+clunk_dur_m-1) &
		.AND. (idpcross(i) .LE. clunk_thr_m) ) THEN
         isubcross(i) = ( 1.d0-clunk_m(1) ) * idpcross(i) * p_t_shock_m(time_m,i,j,k)
         iclunksubsmpcross(i) = 1
         ELSE
         isubcross(i) = 0.d0
         iclunksubsmpcross(i) = 0
         END if
       ELSE
       iadjcross(i) = 0.d0
         IF ( dp_shck_shock_m(time_m,i,j) <= Probdp_m(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
         isubcross(i) = 0.d0
         iclunksubsmpcross(i) = 0
       END IF

       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_shock_m(time_m,i,j,k)
       impcross(i) = ikpcross(i)/q_t_shock_m(time_m,age_t_m(time_m,i),j,k)
       ibpcross(i) = 0.d0
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_shock_m(time_m,i,j,k)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       END IF

	   IF(age_t_m(time_m,i)<=twork*mnth) THEN
	   iwork(i) = 1
	   iwcross(i) = p_t_shock_m(time_m,i,j,k) * u_shck_shock_m(time_m,i,j)*m_shck_shock_m(time_m,age_t_m(time_m,i),k)
	   ELSE
	   iwork(i) = 0
	   iwcross(i)=0.d0
	   END IF

   IF (month==mnth) THEN
   inewcar_an(i) = SUM( inewcar_pnl(i,:) )
   ivalnewcar_an(i) = SUM( ivalnewcar_pnl(i,:) )
   ivalnewcar_byp_an(i) = SUM( ivalnewcar_byp_pnl(i,:) )
     IF (inewcar_an(i) .GT. 1) inewcar_an(i)=1
   END IF

   ELSE
   ic_realcross(i)=0.d0
   ic_realcross_pnl(i,month) = 0.d0
   id_realcross(i)=0.d0
   ix_realcross(i)=0.d0
   iicross(i)=0.d0
   iicross_pnl(i,month)=0.d0
   ii_bypcross(i)=0.d0
   ii_bypcross_pnl(i,month)=0.d0
   iadjcross(i)=0.d0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
   ivalnewcar_byp(i)=0.d0
   inewcar_pnl(i,month) = 0.d0
   ivalnewcar_pnl(i,month) = 0.d0
   ivalnewcar_byp_pnl(i,month) = 0.d0
   ikcross(i)=0.d0
   ikpcross(i) = 0.d0
   ibcross(i)=0.d0
   imcross(i)=0.d0
   iwork(i)=0
   iwcross(i)=0.d0

   IF (month==mnth) THEN
   inewcar_an(i) = 0
   ivalnewcar_an(i) = 0.d0
   ivalnewcar_byp_an(i) = 0.d0
   END IF

   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  newcar(time_m,j,o) = SUM( DBLE(inewcar) )/ SUM(DBLE(alive_t_shock_m(time_m,:,j)))
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time_m,j,o) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  valnewcar_byp(time_m,j,o) = SUM( ivalnewcar_byp ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time_m,j,o) = 0.d0
  valnewcar_byp(time_m,j,o) = 0.d0
  END IF

  IF (month==mnth) THEN
  newcar_an(time,j,o) = SUM( DBLE(inewcar_an) )/ SUM(DBLE(alive_t_shock_m(time_m,:,j)))
  IF (  SUM( DBLE(inewcar_an) ) >0.5d0 ) THEN
  valnewcar_an(time,j,o) = SUM( ivalnewcar_an ) / SUM( DBLE(inewcar_an) )
  valnewcar_byp_an(time,j,o) = SUM( ivalnewcar_byp_an ) / SUM( DBLE(inewcar_an) )
  ELSE
  valnewcar_an(time,j,o) = 0.d0
  valnewcar_byp_an(time,j,o) = 0.d0
  END IF
  END IF

  IF (time_m<numshock_m) THEN
  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t_m(time_m,i)<ng_m) THEN
     IF(age_t_m(time_m,i)<twork*mnth) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k))*&
		v_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)*n_shck_shock_m(time_m+1,i,j))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock_m(time_m+1,age_t_m(time_m+1,i),j,k) * &
		r_m * (iapcross(i)-eta*idpcross(i)) / &
		(gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k))*&
		v_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)*n_shck_shock_m(time_m+1,i,j)) &
		+ (1.d0-delta_m(ideltacross(i)) )*idcross(i) + &
		u_shck_shock_m(time_m+1,i,j)*m_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)
     ELSE
     ixcross(i) = (r_m+rk_t_shock_m(time_m+1,j,k))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k))*&
		v_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)*n_shck_shock_m(time_m+1,i,j)) &
		+ (1.d0-delta_m(ideltacross(i)) )*idcross(i) + &
		u_shck_shock_m(time_m+1,i,j)*m_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock_m(time_m+1,age_t_m(time_m+1,i),j,k) * &
		r_m * (iapcross(i)-eta*idpcross(i)) / &
		gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k)) + &
		(1.d0-delta_m(ideltacross(i)) )*idcross(i)  + u_ret
     ELSE
     ixcross(i) = ( r_m+rk_t_shock_m(time_m+1,j,k) )*( iapcross(i)-eta*idpcross(i) ) / &
		  gnodes_m(age_t_m(time_m+1,i),g_shck_shock_m(time_m+1,i,k)) + &
		  (1.d0-delta_m(ideltacross(i)) )*idcross(i)  +  u_ret
     END IF

     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)

   ELSE
     IF ( init_x_shock_m(i,j) >= 0.d0 ) THEN
     ibcross(i) = 0.d0
     ikcross(i) = init_x_shock_m(i,j) / r_m
     imcross(i) = init_x_shock_m(i,j) / ( r_m*q_t_shock_m(time_m+1,1,j,k) )
     ELSE
     ibcross(i) = ABS( init_x_shock_m(i,j) )/(r_m+rk_t_shock_m(time_m+1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF

   ideltacross(i) = init_delta_shock_m(i,j)
   idcross(i) =  init_d_shock_m(i,j)/p_t_shock_m(time_m+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax_m)
   ixcross(i) =  init_x_shock_m(i,j)/p_t_shock_m(time_m+1,i,j,k) + &
		(1.d0-delta_m(ideltacross(i)) )*idcross(i) + &
		u_shck_shock_m(time_m+1,i,j)*m_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)
   ixcross(i) = MIN( MAX( ixcross(i), xmin_m), xmax_m)
   IF (init_d_nadj_shock_m(i,j)==1) THEN
   CALL sub_pollin_mnth( Vnoadjust_m,Vadjust_m,a_adj_m,a_nadj_m,D_adj_m,&
	 ixcross(i), idcross(i), 1, ideltacross(i), nc, &
	 g_shck_shock_m(time_m+1,i,k), rk_t_shock_m(time_m+1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-(1.d0-delta_m(ideltacross(i)) )*idcross(i)-&
	u_shck_shock_m(time_m+1,i,j)*m_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k) )/ &
	(r_m+rk_t_shock_m(time_m+1,j,k))<-eta*idcross(i) ) THEN
   ixcross(i) = (1.d0-delta_m(ideltacross(i))-eta*(r_m+rk_t_shock_m(time_m+1,j,k)))*idcross(i) + &
	u_shck_shock_m(time_m+1,i,j)*m_shck_shock_m(time_m+1,age_t_m(time_m+1,i),k)
   END IF

   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL
  END IF

  END DO month1
  END DO time1


  END DO rep1
  END DO shck_c1
  END DO policy1

  yr_index = (yr_pr-1)*mnth +1

  OPEN (UNIT=420, FILE="out/Shocksimulate_mnth.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(420,*) newcar, ';'
  WRITE(420,*) valnewcar, ';'
  WRITE(420,*) valnewcar_byp, ';'
  CLOSE(420)

  OPEN (UNIT=448, FILE="out/Shocksimulate_mnth_an.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(448,*) newcar_an, ';'
  WRITE(448,*) valnewcar_an, ';'
  WRITE(448,*) valnewcar_byp_an, ';'
  CLOSE(448)

END SUBROUTINE sub_shocksim_mnth
