SUBROUTINE sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,init_delta_shock,age_t,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,v_shck_shock,m_shck_shock)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng,ndp), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(shocklives,agents,rep), INTENT(IN) :: &
	 init_y_shock, init_x_shock, init_d_shock
  INTEGER, DIMENSION(shocklives,agents,rep) :: init_d_nadj_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(IN) :: init_delta_shock
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(IN) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(IN) :: &
	n_shck_shock, u_shck_shock, dp_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(IN) :: p_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(IN) :: v_shck_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(IN) :: m_shck_shock

  INTEGER :: time, time_i, i, i1, j, k
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
		ibpcross, iwcross, ilwcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ivalnewcar, &
		isavecross, isavecross_r, iinccross, &
		icgrwcross,  m_shckcross, ic_realcross_lag
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, isavshare, ideltacross
  REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: valnewcarmat, iexmat, savemat, &
	 	cgrwmat, loanmat
  INTEGER, DIMENSION(:,:,:,:), ALLOCATABLE :: agemat
  REAL(8), DIMENSION(numshock,rep,shck_c) :: cts, dts, its, iexts, newcar, valnewcar, &
        kts, bts, wts, lwts, sav, inc, cgrwts, pts
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp
  INTEGER :: AllocateStatus
	LOGICAL :: cohortmat_out

  ALLOCATE( valnewcarmat(shockseriesmat_n,agents_out,rep_out,shck_c), &
		iexmat(shockseriesmat_n,agents_out,rep_out,shck_c), &
		savemat(shockseriesmat_n,agents_out,rep_out,shck_c), &
	  loanmat(shockseriesmat_n,agents_out,rep_out,shck_c), &
		cgrwmat(shockseriesmat_n,agents_out,rep_out,shck_c), STAT=AllocateStatus  )

  ALLOCATE( agemat(shockseriesmat_n,agents_out,rep_out,shck_c), STAT=AllocateStatus )

  valnewcarmat=0.d0
  cgrwmat = 0.d0
  agemat=0

  shck_c1: DO k=1, shck_c
  rep1: DO j = 1, rep
  time1: DO time = 1, numshock-1
  !$OMP PARALLEL
  !$OMP DO PRIVATE(u_temp)
   DO i = 1, agents
   IF (time==1) THEN

     IF (age_t(1,i)<=twork) THEN
     u_temp = u_shck_shock(1,i,j)*m_shck_shock(1,age_t(1,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( init_x_shock(1,i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_shock(1,i,j)/r
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(1,i,j) )/(r+rk)
     ikcross(i) = 0.d0
     END IF
   idcross(i) = init_d_shock(1,i,j)/p_t_shock(1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x_shock(1,i,j)/p_t_shock(1,i,j,k) + eta*r*idcross(i) + u_temp
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   ideltacross(i) = init_delta_shock(1,i,j)
   init_loc(i) = 2

   IF (init_d_nadj_shock(1,i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-eta*r*idcross(i)-u_temp)/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = -eta*rk*idcross(i) + u_temp
     END IF
   END IF

   END IF
   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )

   IF (alive_t_shock(time,i,j)==1) THEN
		 IF (  (age_t(time,i) .GT. 1) .AND. (ic_realcross(i)>0) .AND. (iccross(i)>0) ) THEN
			icgrwcross(i) = LOG( iccross(i) * p_t_shock(time,i,j,k) ) - LOG( ic_realcross(i) )
		 ELSE
		  icgrwcross(i) = 0.d0
		 END IF
     ic_realcross(i) = iccross(i) * p_t_shock(time,i,j,k)
     id_realcross(i) = idcross(i) * p_t_shock(time,i,j,k)
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t_shock(time,i,j,k)
       IF (adjcross(i)==2 .AND. &
			 		idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i)  = (idpcross(i) - idcross(i)) * p_t_shock(time,i,j,k)
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       END IF
       IF (adjcross(i)==2) THEN
			 iadjcross(i) = F * id_realcross(i)
       ideltacross(i) = 2
       ELSE
       iadjcross(i) = 0.d0
         IF ( dp_shck_shock(time,i,j) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF
       IF (age_t(time,i)<=twork) THEN
       u_temp = u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
			 ELSE
       u_temp =  u_ret
       END IF
       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       ibpcross(i) = 0.d0
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       ikpcross(i) = 0.d0
       END IF

    IF (ikcross(i) .GE. 0) THEN
    iinccross(i) = p_t_shock(time,i,j,k)*u_temp + (r-1.d0)*ikcross(i)
    isavecross(i) = iinccross(i) - iicross(i) - iadjcross(i) - ic_realcross(i)
    isavecross_r(i) = (iicross(i) + iadjcross(i) + ic_realcross(i)) / iinccross(i)
    ELSE
    iinccross(i) = p_t_shock(time,i,j,k)*u_temp
    isavecross(i) = iinccross(i) - iicross(i) - iadjcross(i) - ic_realcross(i) - &
				(r+rk-1.d0)*ibcross(i)
    isavecross_r(i) = (iicross(i) + iadjcross(i) + ic_realcross(i) &
				+ (r+rk-1.d0)*ibcross(i) ) / iinccross(i)
    END IF


   IF(age_t(time,i)<=twork) THEN
   iwork(i) = 1
   iwcross(i) = p_t_shock(time,i,j,k) * u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
   ilwcross(i) = LOG( iwcross(i) )
   ELSE
   iwork(i) = 0
   iwcross(i)=0.d0
   ilwcross(i) = 0.d0
	 m_shckcross(i) = 0.d0
   END IF

   ELSE
   ic_realcross(i)=0.d0
	 icgrwcross(i) = 0.d0
   id_realcross(i)=0.d0
   iicross(i)=0.d0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
	 iadjcross(i) = 0.d0
   ikcross(i)=0.d0
   ibcross(i)=0.d0
	 ibpcross(i)=0.d0
   iinccross(i) = 0.d0
   isavecross_r(i) = 0.d0
   iwork(i)=0
   iwcross(i)=0.d0
   ilwcross(i)=0.d0
   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL


    IF (j<=rep_out) THEN
  ! Update states
  !$OMP PARALLEL
  !$OMP DO PRIVATE(i1)
   DO i = 1, agents_out
   i1 = (i-1)*agents_out_sc + 1
     IF (time>=numshock-shockseriesmat_n .AND. time<numshock) THEN
      time_i = time - (numshock-shockseriesmat_n-1)
      IF (alive_t_shock(time,i1,j)==1) THEN
      agemat(time_i,i,j,k) = age_t(time,i1)
				IF ( agemat(time_i,i,j,k)>1 .AND. &
					ic_realcross(i1)>0 .AND. ic_realcross_lag(i1)>0  ) THEN
					cgrwmat(time_i,i,j,k) = LOG( ic_realcross(i1) ) - LOG( ic_realcross_lag(i1) )
				ELSE
					cgrwmat(time_i,i,j,k) = -123.d0
				END IF
      iexmat(time_i,i,j,k) = ivalnewcar(i1)

      savemat(time_i,i,j,k) = isavecross_r(i1)
			loanmat(time_i,i,j,k) = ibpcross(i1)
      IF (inewcar(i1)==1) THEN
      valnewcarmat(time_i,i,j,k) = ivalnewcar(i1)
      ELSE
      valnewcarmat(time_i,i,j,k) = -123.d0
      END IF
      ELSE
      agemat(time_i,i,j,k) = -1
      END IF
     END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL
   END IF

  cts(time,j,k)   = SUM( ic_realcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
	cgrwts(time,j,k)   = SUM( icgrwcross ) / (SUM(DBLE(alive_t_shock(time,:,j))) -agent_age)
  its(time,j,k)   = SUM( iicross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  iexts(time,j,k) = SUM( ivalnewcar ) / SUM(DBLE(alive_t_shock(time,:,j)))
  newcar(time,j,k) = SUM( DBLE(inewcar) )/ SUM(DBLE(alive_t_shock(time,:,j)))
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time,j,k) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time,j,k) = 0.d0
  END IF
  kts(time,j,k) = SUM( ikcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  bts(time,j,k) = SUM( ibcross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  wts(time,j,k)   = SUM( iwcross ) / SUM( DBLE(iwork) )
  lwts(time,j,k)  = SUM( ilwcross ) / SUM( DBLE(iwork) )
  sav(time,j,k)   = SUM( isavecross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  inc(time,j,k)   = SUM( iinccross ) / SUM(DBLE(alive_t_shock(time,:,j)))
  pts(time,j,k) = SUM( p_t_shock(time,:,j,k), MASK=iwork .EQ. 1 )/SUM( DBLE(iwork) )

  ! Update states
  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * iapcross(i) / &
		(gnodes(age_t(time+1,i))*v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     ELSE
     ixcross(i) = ( r*iapcross(i) +rk*(iapcross(i)-eta*idpcross(i)) ) / &
		(gnodes(age_t(time+1,i))*v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     END IF
     idcross(i) = idpcross(i)/ &
		(gnodes(age_t(time+1,i))*v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j))
     ELSE
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * iapcross(i) / gnodes(age_t(time+1,i)) + u_ret
     ELSE
     ixcross(i) = ( r*iapcross(i) +rk*(iapcross(i)-eta*idpcross(i)) ) / &
		   gnodes(age_t(time+1,i)) + u_ret
     END IF
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i))
     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)

   ELSE

     IF ( init_x_shock(init_loc(i),i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_shock(init_loc(i),i,j)/r
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(init_loc(i),i,j) )/(r+rk)
     ikcross(i) = 0.d0
     END IF
   idcross(i) =  init_d_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k) + &
			r*eta*idcross(i) + u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   ideltacross(i) = init_delta_shock(init_loc(i),i,j)
   IF (init_d_nadj_shock(init_loc(i),i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-eta*r*idcross(i)-&
			u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k))/(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = -eta*rk*idcross(i) + u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
   END IF

   init_loc(i) = init_loc(i)+1
   END IF
	 ic_realcross_lag(i) = ic_realcross(i)

   END DO
  !$OMP END DO
  !$OMP END PARALLEL


  END DO time1
  END DO rep1
  END DO shck_c1

  OPEN (UNIT=420, FILE="out/Shocksimulate.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(420,*) cts, ';'
	WRITE(420,*) cgrwts, ';'
  WRITE(420,*) its, ';'
  WRITE(420,*) newcar, ';'
  WRITE(420,*) valnewcar, ';'
  WRITE(420,*) bts, ';'
  WRITE(420,*) sav, ';'
  WRITE(420,*) inc, ';'
	WRITE(420,*) wts, ';'
  WRITE(420,*) lwts, ';'
	WRITE(420,*) pts, ';'
  CLOSE(420)

  OPEN (UNIT=228, FILE='out/Shockmat_cohort.txt', ACTION="WRITE", POSITION="REWIND")
!	OPEN (UNIT=228, FILE='PATH/income_only/out/Shockmat_cohort.txt', &
!	  ACTION="WRITE", POSITION="REWIND")
  WRITE(228,*) cgrwmat(:,:,:,1), ';'
  WRITE(228,*) iexmat(:,:,:,1), ';'
  WRITE(228,*) valnewcarmat(:,:,:,1), ';'
  WRITE(228,*) savemat(:,:,:,1), ';'
	WRITE(228,*) loanmat(:,:,:,1), ';'
  WRITE(228,*) agemat(:,:,:,1), ';'
  CLOSE(228)

  OPEN (UNIT=228, FILE='out/Shockmat_uniform.txt', ACTION="WRITE", POSITION="REWIND")
!	OPEN (UNIT=228, FILE='PATH/income_only/out/Shockmat_uniform.txt', &
!	  ACTION="WRITE", POSITION="REWIND")
  WRITE(228,*) cgrwmat(:,:,:,2), ';'
  WRITE(228,*) iexmat(:,:,:,2), ';'
  WRITE(228,*) valnewcarmat(:,:,:,2), ';'
  WRITE(228,*) savemat(:,:,:,2), ';'
	WRITE(228,*) loanmat(:,:,:,2), ';'
  WRITE(228,*) agemat(:,:,:,2), ';'
  CLOSE(228)

  DEALLOCATE( valnewcarmat, iexmat, savemat, cgrwmat, agemat, loanmat )



END SUBROUTINE sub_shocksim
