SUBROUTINE sub_irfsim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_irf,init_x_irf,init_d_irf,init_d_nadj_irf,init_delta_irf,&
	age_t,alive_t_irf, &
	n_shck_irf,u_shck_irf,p_t_irf,dp_shck_irf,v_shck_irf,m_shck_irf,s_shck_irf)

USE OMP_LIB
USE share

IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: &
	 init_y_irf, init_x_irf, init_d_irf
  INTEGER, DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: init_d_nadj_irf
  INTEGER, DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: init_delta_irf
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
  INTEGER, DIMENSION(numirf,agents,rep_irf), INTENT(IN) :: alive_t_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf), INTENT(IN) :: dp_shck_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf,irf_c), INTENT(IN) :: u_shck_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf,irf_c), INTENT(IN) :: n_shck_irf, &
	p_t_irf
  REAL(8), DIMENSION(numirf,twork,rep_irf,irf_c), INTENT(IN) :: v_shck_irf, m_shck_irf
  INTEGER, DIMENSION(numirf,twork,rep_irf,irf_c), INTENT(IN) :: s_shck_irf

  INTEGER :: time, time_i, i, j, k
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	ibpcross, iwcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ivalnewcar, &
	iapcross_max, idpcross_max, iinccross
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, ideltacross
	REAL(8), DIMENSION(agents) :: idcross0, ixcross0, ikcross0, ibcross0
	INTEGER, DIMENSION(agents) :: ideltacross0, init_loc0
  REAL(8), DIMENSION(numirf,rep_irf,irf_c) :: cts, dts, its, iexts, &
	 		newcar, valnewcar, wts, alive
	REAL(8), DIMENSION(agents) :: ivalnewcar2, imaint
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp
  INTEGER :: AllocateStatus

  rep_irf1: DO j = 1, rep_irf
  irf_c1: DO k=1, irf_c
  time1: DO time = 1, numirf-1

	IF (k==1 .OR. time.GE.ng) THEN
  !$OMP PARALLEL DO PRIVATE(u_temp)
   DO i = 1, agents
   IF (time==1) THEN
     IF (age_t(1,i)<=twork) THEN
     u_temp = u_shck_irf(1,i,j,k)*m_shck_irf(1,age_t(1,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( init_x_irf(1,i,j) >= 0.d0) THEN
     ikcross(i) = init_x_irf(1,i,j)/r
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_irf(1,i,j) )/(r+rk)
     ikcross(i) = 0.d0
     END IF
   idcross(i) = init_d_irf(1,i,j)/p_t_irf(1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x_irf(1,i,j)/p_t_irf(1,i,j,k) + eta*r*idcross(i) + u_temp
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   ideltacross(i) = init_delta_irf(1,i,j)
   init_loc(i) = 2

   IF (init_d_nadj_irf(1,i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), &
	 s_shck_irf(1,MIN(age_t(1,i),twork),j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-eta*r*idcross(i)-u_temp)/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = -eta*rk*idcross(i) + u_temp
     END IF
   END IF
   END IF
   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
		 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), &
		 s_shck_irf(time,MIN(age_t(time,i),twork),j,k), &
		 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   IF (alive_t_irf(time,i,j)==1) THEN
     ic_realcross(i) = iccross(i) * p_t_irf(time,i,j,k)
     id_realcross(i) = idcross(i) * p_t_irf(time,i,j,k)
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t_irf(time,i,j,k)

   IF (adjcross(i)==2 .AND. &
idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
   inewcar(i) = 1
   ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t_irf(time,i,j,k)
   ELSE
   inewcar(i) = 0
   ivalnewcar(i) = 0.d0
   END IF

   IF (adjcross(i)==2) THEN
	 imaint(i) = 0.d0
   ideltacross(i) = 2
	 ivalnewcar2(i) = iicross(i)
   ELSE
	 imaint(i) = delta(ideltacross(i))*id_realcross(i) * gamma
	 	 ivalnewcar2(i) = 0.d0
     IF ( dp_shck_irf(time,i,j) <= Probdp(ideltacross(i),1) ) THEN
     ideltacross(i) = 1
     ELSE
     ideltacross(i) = 2
     END IF
   END IF

   IF (age_t(time,i)<=twork) THEN
   u_temp = u_shck_irf(time,i,j,k)*m_shck_irf(time,age_t(time,i),j,k)
   ELSE
   u_temp =  u_ret
   END IF
   IF (iapcross(i)>=eta*idpcross(i)) THEN
   ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_irf(time,i,j,k)
   ibpcross(i) = 0.d0

   ELSE
   ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_irf(time,i,j,k)
   ikpcross(i) = 0.d0
   END IF

   IF(age_t(time,i)<=twork) THEN
   iwork(i) = 1
   iwcross(i) = p_t_irf(time,i,j,k) * u_shck_irf(time,i,j,k)*m_shck_irf(time,age_t(time,i),j,k)
   ELSE
   iwork(i) = 0
   iwcross(i)=0.d0
   END IF

   ELSE
   ic_realcross(i)=0.d0
   id_realcross(i)=0.d0
   iicross(i)=0.d0
	 adjcross(i)=0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
	 ivalnewcar2(i)=0.d0
 	 imaint(i) = 0.d0
   ikcross(i)=0.d0
   ibcross(i)=0.d0
   iwork(i)=0
   iwcross(i)=0.d0
   END IF
   END DO
  !$OMP END PARALLEL DO

	alive(time,j,k) = SUM(DBLE(alive_t_irf(time,:,j)))
  cts(time,j,k)   = SUM( ic_realcross ) / SUM(DBLE(alive_t_irf(time,:,j)))
  its(time,j,k)   = SUM( iicross ) / SUM(DBLE(alive_t_irf(time,:,j)))
  iexts(time,j,k) = SUM( ivalnewcar ) / SUM(DBLE(alive_t_irf(time,:,j)))
  newcar(time,j,k) = SUM( DBLE(inewcar) )/ SUM(DBLE(alive_t_irf(time,:,j)))
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time,j,k) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time,j,k) = 0.d0
  END IF
  wts(time,j,k)   = SUM(iwcross ) / SUM( DBLE(iwork) )

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * iapcross(i) / &
				(gnodes(age_t(time+1,i))* &
				v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j,k)) &
				+ u_shck_irf(time+1,i,j,k)*m_shck_irf(time+1,age_t(time+1,i),j,k)
     ELSE
     ixcross(i) = ( r*iapcross(i) +rk*(iapcross(i)-eta*idpcross(i)) ) / &
				(gnodes(age_t(time+1,i))* &
				v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j,k)) &
				+ u_shck_irf(time+1,i,j,k)*m_shck_irf(time+1,age_t(time+1,i),j,k)
     END IF
     idcross(i) = idpcross(i)/ &
				(gnodes(age_t(time+1,i))* &
				v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j,k))
     ELSE
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * iapcross(i) / gnodes(age_t(time+1,i)) + u_ret
     ELSE
     ixcross(i) = ( r*iapcross(i) +rk*(iapcross(i)-eta*idpcross(i)) ) / &
		   gnodes(age_t(time+1,i)) + u_ret
     END IF
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i))
     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)

   ELSE
     IF ( init_x_irf(init_loc(i),i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_irf(init_loc(i),i,j)/r
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_irf(init_loc(i),i,j) )/(r+rk)
     ikcross(i) = 0.d0
     END IF
   idcross(i) =  init_d_irf(init_loc(i),i,j)/p_t_irf(time+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x_irf(init_loc(i),i,j)/p_t_irf(time+1,i,j,k) + &
			eta*r*idcross(i) + u_shck_irf(time+1,i,j,k)*m_shck_irf(time+1,age_t(time+1,i),j,k)
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   ideltacross(i) = init_delta_irf(init_loc(i),i,j)

   IF (init_d_nadj_irf(init_loc(i),i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), &
	 s_shck_irf(time+1,MIN(age_t(time+1,i),twork),j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-eta*r*idcross(i)-&
	u_shck_irf(time+1,i,j,k)*m_shck_irf(time+1,age_t(time+1,i),j,k) &
	)/(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = -eta*rk*idcross(i) + u_shck_irf(time+1,i,j,k)*m_shck_irf(time+1,age_t(time+1,i),j,k)
   END IF
   init_loc(i) = init_loc(i)+1
   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL

	END IF

	IF (time .EQ. ng-1) THEN
	 IF (k .EQ. 1) THEN
	 ixcross0 = ixcross
	 idcross0 = idcross
	 ideltacross0 = ideltacross
	 init_loc0 = init_loc

	 ikcross0 = ikcross
	 ibcross0 = ibcross
	 ELSE
	 ixcross = ixcross0
	 idcross = idcross0
	 ideltacross = ideltacross0
	 init_loc = init_loc0

	 ikcross = ikcross0
	 ibcross = ibcross0
	 END IF
END IF


  END DO time1
  END DO irf_c1
  END DO rep_irf1

  OPEN (UNIT=420, FILE="out/Irf_agg_unc.txt", ACTION="WRITE", POSITION="REWIND")
	WRITE(420,*) cts, ';'
  WRITE(420,*) its, ';'
	WRITE(420,*) valnewcar, ';'
  WRITE(420,*) wts, ';'
  CLOSE(420)

END SUBROUTINE sub_irfsim
