* Produce Regressions for TABLE 1
local folder = "..\empirical\table1"
cd `folder'


clear

u quarterly_scarscex_replication

gen year_q_sq = year_q^2

* Quarter dummies
gen q_dummy2 = 0
gen q_dummy3 = 0
gen q_dummy4 = 0
replace q_dummy2 = 1 if (month==4 | month==5 | month==6)
replace q_dummy3 = 1 if (month==7 | month==8 | month==9)
replace q_dummy4 = 1 if (month==10 | month==11 | month==12)

regress P_BUY nber_recess greatrecess q_dummy* year_q year_q_sq 
regress P_BUY_new nber_recess greatrecess q_dummy* year_q year_q_sq 
regress P_BUY_old nber_recess greatrecess q_dummy* year_q year_q_sq 

regress CARSPEND nber_recess greatrecess q_dummy* year_q year_q_sq 
regress newcar nber_recess greatrecess q_dummy* year_q year_q_sq 
regress oldcar nber_recess greatrecess q_dummy* year_q year_q_sq 