SUBROUTINE sub_pollin_mnth(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	ixcross,idcross,iage,idp,ic,igp,irk,iapcross,idpcross,ccross,adjcross )

 USE share
 IMPLICIT NONE
 REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
 REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
 REAL(8), INTENT(IN) :: ixcross, idcross
 INTEGER, INTENT(IN) :: iage, idp, ic, igp
 REAL(8), INTENT(IN) :: irk
 REAL(8), INTENT(OUT) :: iapcross, idpcross, ccross
 INTEGER, INTENT(OUT) :: adjcross

 REAL(8) :: v_adj, v_noadj
 REAL(8) :: s0,s1,s2,s3,s4,s5,s6,s7
 REAL(8) :: x1,x2,x3,w1,w2,w3
 INTEGER :: y1,y2,y3

 x1 = MAX ( MIN ( ixcross , xmax_m ), xmin_m )
 x2 = MAX ( MIN ( idcross , Dmax_m ), Dmin )
 x3 = MAX ( MIN ( irk , rkmax_m ), rkmin_m )

   y1 = MINLOC(ABS(x1-xnodes_m),1)
   IF (x1==xnodes_m(y1)) THEN
    IF (y1<nx) THEN
        w1=1.d0
    ELSE
        y1=y1-1
        w1=0.d0
    END IF
   ELSE
    IF (x1-xnodes_m(y1)>0.d0) THEN
        w1=1.d0-( x1-xnodes_m(y1) )/ ( xnodes_m(y1+1)-xnodes_m(y1) )
    ELSE
        y1=y1-1
        w1=1.d0-( x1-xnodes_m(y1) )/ ( xnodes_m(y1+1)-xnodes_m(y1) )
    END IF
   END IF

   y2 = MINLOC(ABS(x2-Dnodes_m),1)
   IF (x2==Dnodes_m(y2)) THEN
    IF (y2<nD) THEN
        w2=1.d0
    ELSE
        y2=y2-1
        w2=0.d0
    END IF
   ELSE
    IF (x2-Dnodes_m(y2)>0.d0) THEN
        w2=1.d0-( x2-Dnodes_m(y2) )/ ( Dnodes_m(y2+1)-Dnodes_m(y2) )
    ELSE
        y2=y2-1
        w2=1.d0-( x2-Dnodes_m(y2) )/ ( Dnodes_m(y2+1)-Dnodes_m(y2) )
    END IF
   END IF

   y3 = MINLOC(ABS(x3-rknodes_m),1)
   IF (x3==rknodes_m(y3)) THEN
    IF (y3<nrk) THEN
        w3=1.d0
    ELSE
        y3=y3-1
        w3=0.d0
    END IF
   ELSE
    IF (x3-rknodes_m(y3)>0.d0) THEN
        w3=1.d0-( x3-rknodes_m(y3) )/ ( rknodes_m(y3+1)-rknodes_m(y3) )
    ELSE
        y3=y3-1
        w3=1.d0-( x3-rknodes_m(y3) )/ ( rknodes_m(y3+1)-rknodes_m(y3) )
    END IF
   END IF

 s0 = Vadjust(y1,y2,iage,idp,ic,igp,y3)
 s1 = Vadjust(y1+1,y2,iage,idp,ic,igp,y3)
 s2 = Vadjust(y1,y2+1,iage,idp,ic,igp,y3)
 s3 = Vadjust(y1+1,y2+1,iage,idp,ic,igp,y3)
 s4 = Vadjust(y1,y2,iage,idp,ic,igp,y3+1)
 s5 = Vadjust(y1+1,y2,iage,idp,ic,igp,y3+1)
 s6 = Vadjust(y1,y2+1,iage,idp,ic,igp,y3+1)
 s7 = Vadjust(y1+1,y2+1,iage,idp,ic,igp,y3+1)

 v_adj = s0 * w1*w2*w3 + &
	 s1 * (1.d0-w1)*w2*w3 + &
	 s2 * w1*(1.d0-w2)*w3 + &
	 s3 * (1.d0-w1)*(1.d0-w2)*w3 + &
	 s4 * w1*w2*(1.d0-w3) + &
	 s5 * (1.d0-w1)*w2*(1.d0-w3) + &
	 s6 * w1*(1.d0-w2)*(1.d0-w3) + &
	 s7 * (1.d0-w1)*(1.d0-w2)*(1.d0-w3)

 s0 = Vnoadjust(y1,y2,iage,idp,ic,igp,y3)
 s1 = Vnoadjust(y1+1,y2,iage,idp,ic,igp,y3)
 s2 = Vnoadjust(y1,y2+1,iage,idp,ic,igp,y3)
 s3 = Vnoadjust(y1+1,y2+1,iage,idp,ic,igp,y3)
 s4 = Vnoadjust(y1,y2,iage,idp,ic,igp,y3+1)
 s5 = Vnoadjust(y1+1,y2,iage,idp,ic,igp,y3+1)
 s6 = Vnoadjust(y1,y2+1,iage,idp,ic,igp,y3+1)
 s7 = Vnoadjust(y1+1,y2+1,iage,idp,ic,igp,y3+1)

 v_noadj =  s0 * w1*w2*w3 + &
	 s1 * (1.d0-w1)*w2*w3 + &
	 s2 * w1*(1.d0-w2)*w3 + &
	 s3 * (1.d0-w1)*(1.d0-w2)*w3 + &
	 s4 * w1*w2*(1.d0-w3) + &
	 s5 * (1.d0-w1)*w2*(1.d0-w3) + &
	 s6 * w1*(1.d0-w2)*(1.d0-w3) + &
	 s7 * (1.d0-w1)*(1.d0-w2)*(1.d0-w3)

 IF (v_adj >= v_noadj) THEN
 adjcross = 2

 s0 = a_adj(y1,y2,iage,idp,ic,igp,y3)
 s1 = a_adj(y1+1,y2,iage,idp,ic,igp,y3)
 s2 = a_adj(y1,y2+1,iage,idp,ic,igp,y3)
 s3 = a_adj(y1+1,y2+1,iage,idp,ic,igp,y3)
 s4 = a_adj(y1,y2,iage,idp,ic,igp,y3+1)
 s5 = a_adj(y1+1,y2,iage,idp,ic,igp,y3+1)
 s6 = a_adj(y1,y2+1,iage,idp,ic,igp,y3+1)
 s7 = a_adj(y1+1,y2+1,iage,idp,ic,igp,y3+1)

 iapcross =  s0 * w1*w2*w3 + &
	 s1 * (1.d0-w1)*w2*w3 + &
	 s2 * w1*(1.d0-w2)*w3 + &
	 s3 * (1.d0-w1)*(1.d0-w2)*w3 + &
	 s4 * w1*w2*(1.d0-w3) + &
	 s5 * (1.d0-w1)*w2*(1.d0-w3) + &
	 s6 * w1*(1.d0-w2)*(1.d0-w3) + &
	 s7 * (1.d0-w1)*(1.d0-w2)*(1.d0-w3)

 s0 = D_adj(y1,y2,iage,idp,ic,igp,y3)
 s1 = D_adj(y1+1,y2,iage,idp,ic,igp,y3)
 s2 = D_adj(y1,y2+1,iage,idp,ic,igp,y3)
 s3 = D_adj(y1+1,y2+1,iage,idp,ic,igp,y3)
 s4 = D_adj(y1,y2,iage,idp,ic,igp,y3+1)
 s5 = D_adj(y1+1,y2,iage,idp,ic,igp,y3+1)
 s6 = D_adj(y1,y2+1,iage,idp,ic,igp,y3+1)
 s7 = D_adj(y1+1,y2+1,iage,idp,ic,igp,y3+1)

 idpcross =  s0 * w1*w2*w3 + &
	 s1 * (1.d0-w1)*w2*w3 + &
	 s2 * w1*(1.d0-w2)*w3 + &
	 s3 * (1.d0-w1)*(1.d0-w2)*w3 + &
	 s4 * w1*w2*(1.d0-w3) + &
	 s5 * (1.d0-w1)*w2*(1.d0-w3) + &
	 s6 * w1*(1.d0-w2)*(1.d0-w3) + &
	 s7 * (1.d0-w1)*(1.d0-w2)*(1.d0-w3)

 IF (idpcross .LE. clunk_thr_m) THEN
 ccross = ixcross - F*idcross -(clunk(ic)-eta)*idpcross - iapcross
 ELSE
 ccross = ixcross - F*idcross -(1.d0-eta)*idpcross - iapcross
 END IF

 ELSE
 adjcross = 1
 idpcross = (1.d0-delta_m(idp)*(1.d0-gamma_m) )*idcross

 s0 = a_nadj(y1,y2,iage,idp,ic,igp,y3)
 s1 = a_nadj(y1+1,y2,iage,idp,ic,igp,y3)
 s2 = a_nadj(y1,y2+1,iage,idp,ic,igp,y3)
 s3 = a_nadj(y1+1,y2+1,iage,idp,ic,igp,y3)
 s4 = a_nadj(y1,y2,iage,idp,ic,igp,y3+1)
 s5 = a_nadj(y1+1,y2,iage,idp,ic,igp,y3+1)
 s6 = a_nadj(y1,y2+1,iage,idp,ic,igp,y3+1)
 s7 = a_nadj(y1+1,y2+1,iage,idp,ic,igp,y3+1)

 iapcross =  s0 * w1*w2*w3 + &
	 s1 * (1.d0-w1)*w2*w3 + &
	 s2 * w1*(1.d0-w2)*w3 + &
	 s3 * (1.d0-w1)*(1.d0-w2)*w3 + &
	 s4 * w1*w2*(1.d0-w3) + &
	 s5 * (1.d0-w1)*w2*(1.d0-w3) + &
	 s6 * w1*(1.d0-w2)*(1.d0-w3) + &
	 s7 * (1.d0-w1)*(1.d0-w2)*(1.d0-w3)

 ccross = ixcross - iapcross - (1.d0-eta)*idpcross

 END IF


END SUBROUTINE
