SUBROUTINE sub_irfsim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_irf,init_x_irf,init_d_irf,init_d_nadj_irf,init_delta_irf,&
	age_t,coh0,alive_t_irf, &
	n_shck_irf,u_shck_irf,p_t_irf,dp_shck_irf,q_t_irf,rk_t_irf, &
	v_shck_irf,m_shck_irf,w_shck_irf,g_shck_irf)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: &
	 init_y_irf, init_x_irf, init_d_irf
  INTEGER, DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: init_d_nadj_irf
  INTEGER, DIMENSION(irflives,agents,rep_irf), INTENT(IN) :: init_delta_irf
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
	INTEGER, DIMENSION(agents), INTENT(IN) :: coh0
  INTEGER, DIMENSION(numirf,agents,rep_irf), INTENT(IN) :: alive_t_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf), INTENT(IN) :: &
	n_shck_irf, dp_shck_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf), INTENT(IN) :: u_shck_irf
  REAL(8), DIMENSION(numirf,agents,rep_irf,irf_c), INTENT(IN) :: p_t_irf
  REAL(8), DIMENSION(numirf,ng,rep_irf,irf_c), INTENT(IN) :: q_t_irf, w_shck_irf
  REAL(8), DIMENSION(numirf,ng,rep_irf,irf_c), INTENT(IN) :: rk_t_irf
  REAL(8), DIMENSION(numirf,twork,rep_irf,irf_c), INTENT(IN) :: v_shck_irf, m_shck_irf
  INTEGER, DIMENSION(numirf,ng,irf_c), INTENT(IN) :: g_shck_irf

  INTEGER :: time, time_i, i, i1, j, k, l
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	ibpcross, iwcross, imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, &
	ivalnewcar, ivalnewcar2, isavecross, iinccross, ival_ccross, imaint
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, isavshare, ideltacross
	REAL(8), DIMENSION(agents) :: idcross0, ixcross0, ikcross0, ibcross0, imcross0
	INTEGER, DIMENSION(agents) :: ideltacross0, init_loc0
  REAL(8), DIMENSION(numirf,rep_irf,irf_c) :: cts, its, iexts, newcar, valnewcar, &
		wts, sav, inc, val_cts, alive
	REAL(8), DIMENSION(numirf,rep_irf,irf_c,coh_out) :: its_coh, adjust_coh, valnewcar2_coh, &
		sav_coh, inc_coh, alive_coh, val_cts_coh, maintts_coh

  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp
  INTEGER :: AllocateStatus

  rep_irf1: DO j = 1, rep_irf
  irf_c1: DO k=1, irf_c
	time1: DO time = 1, numirf

	IF (k==1 .OR. time.GE.ng) THEN
  !$OMP PARALLEL
  !$OMP DO PRIVATE(u_temp)
   DO i = 1, agents

   IF (time==1) THEN
     IF (age_t(1,i)<=twork) THEN
     u_temp = u_shck_irf(1,i,j)*m_shck_irf(1,age_t(1,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( init_x_irf(1,i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_irf(1,i,j) /r
     imcross(i) = init_x_irf(1,i,j) / (r*q_t_irf(1,age_t(1,i),j,k))
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_irf(1,i,j) )/(r+rk_t_irf(1,age_t(1,i),j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF
   ideltacross(i) = init_delta_irf(1,i,j)
   idcross(i) = init_d_irf(1,i,j)/p_t_irf(1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x_irf(1,i,j)/p_t_irf(1,i,j,k) &
	 + (1.d0-delta(ideltacross(i)))*idcross(i) + u_temp
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   init_loc(i) = 2

   IF (init_d_nadj_irf(1,i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), g_shck_irf(1,age_t(1,i),k), rk_t_irf(1,age_t(1,i),j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)-u_temp)/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + u_temp
     END IF
   END IF
   END IF

   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), g_shck_irf(time,age_t(time,i),k), rk_t_irf(time,age_t(time,i),j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )

   IF (alive_t_irf(time,i,j)==1) THEN
     ic_realcross(i) = iccross(i) * p_t_irf(time,i,j,k)
     id_realcross(i) = idcross(i) * p_t_irf(time,i,j,k)
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t_irf(time,i,j,k)
       IF (adjcross(i)==2 .AND. &
			 	idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t_irf(time,i,j,k)
			 ival_ccross(i) = ivalnewcar(i) / ic_realcross(i)
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
			 ival_ccross(i) = 0.d0
       END IF

       IF (adjcross(i)==2) THEN
			 imaint(i) = 0.d0
       ideltacross(i) = 2
			 ivalnewcar2(i) = iicross(i)
       ELSE
			 imaint(i) = delta(ideltacross(i))*id_realcross(i) * gamma
			 ivalnewcar2(i) = 0.d0
         IF ( dp_shck_irf(time,i,j) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF

       IF (age_t(time,i)<=twork) THEN
       u_temp = u_shck_irf(time,i,j)*m_shck_irf(time,age_t(time,i),j,k)
       ELSE
       u_temp =  u_ret
       END IF
       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_irf(time,i,j,k)
       impcross(i) = ikpcross(i)/q_t_irf(time,age_t(time,i),j,k)
       ibpcross(i) = 0.d0
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_irf(time,i,j,k)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       END IF

    IF (ikcross(i) .GE. 0) THEN
    iinccross(i) = p_t_irf(time,i,j,k)*u_temp + (r-1.d0)*q_t_irf(time,age_t(time,i),j,k)*imcross(i)
    isavecross(i) = iinccross(i) - iicross(i) - iadjcross(i) - ic_realcross(i)
    ELSE
    iinccross(i) = p_t_irf(time,i,j,k)*u_temp
    isavecross(i) = iinccross(i) - (r+rk_t_irf(time,age_t(time,i),j,k)-1.d0)*ibcross(i) &
	 			- iicross(i) - iadjcross(i) - ic_realcross(i)
    END IF

   IF(age_t(time,i)<=twork) THEN
   iwork(i) = 1
   iwcross(i) = p_t_irf(time,i,j,k) * u_shck_irf(time,i,j) * m_shck_irf(time,age_t(time,i),j,k)
   ELSE
   iwork(i) = 0
   iwcross(i)=0.d0
   END IF

   ELSE
   ic_realcross(i)=0.d0
   id_realcross(i)=0.d0
   iicross(i)=0.d0
	 adjcross(i)=0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
	 ivalnewcar2(i)=0.d0
	 ival_ccross(i)=0.d0
	 imaint(i) = 0.d0
   ikcross(i)=0.d0
   ikpcross(i) = 0.d0
   ibcross(i)=0.d0
   imcross(i)=0.d0
   iinccross(i) = 0.d0
   isavecross(i) = 0.d0
   iwork(i)=0
   iwcross(i)=0.d0
   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

	alive(time,j,k) = SUM(DBLE(alive_t_irf(time,:,j)))
  cts(time,j,k)   = SUM( ic_realcross ) / alive(time,j,k)
  its(time,j,k)   = SUM( iicross ) / alive(time,j,k)
  iexts(time,j,k) = SUM( ivalnewcar ) / alive(time,j,k)
  newcar(time,j,k) = SUM( DBLE(inewcar) )/ alive(time,j,k)
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time,j,k) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
	val_cts(time,j,k) = SUM( ival_ccross ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time,j,k) = 0.d0
	val_cts(time,j,k) = 0.d0
  END IF
  wts(time,j,k)   = SUM(iwcross ) / SUM( DBLE(iwork) )
  sav(time,j,k)   = SUM( isavecross ) / alive(time,j,k)
  inc(time,j,k)   = SUM( iinccross ) / alive(time,j,k)

	DO l=1,coh_out
		alive_coh(time,j,k,l)   = SUM(DBLE(alive_t_irf(time,:,j)), MASK=coh0 .EQ. l)
		its_coh(time,j,k,l)   = SUM( iicross, MASK=coh0 .EQ. l ) / alive_coh(time,j,k,l)
		adjust_coh(time,j,k,l) = SUM( DBLE(adjcross), MASK=coh0 .EQ. l )/ alive_coh(time,j,k,l) - 1.d0
		IF (  adjust_coh(time,j,k,l) > 0.d0 ) THEN
		valnewcar2_coh(time,j,k,l) = SUM( ivalnewcar2, MASK=coh0 .EQ. l  ) / ( adjust_coh(time,j,k,l)*alive_coh(time,j,k,l) )
		ELSE
		valnewcar2_coh(time,j,k,l) = 0.d0
		END IF
		IF (  adjust_coh(time,j,k,l) < 1.d0 ) THEN
		maintts_coh(time,j,k,l) = SUM( imaint, MASK=coh0 .EQ. l )/( alive_coh(time,j,k,l)*(1.d0-adjust_coh(time,j,k,l)) )
		ELSE
		maintts_coh(time,j,k,l) = 0.d0
		END IF
		sav_coh(time,j,k,l)   = SUM( isavecross, MASK=coh0 .EQ. l) / alive_coh(time,j,k,l)
		inc_coh(time,j,k,l)   = SUM( iinccross, MASK=coh0 .EQ. l) / alive_coh(time,j,k,l)
  END DO

  IF (time<numirf) THEN

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k))*&
		v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_irf(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		(gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k))*&
		v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)))*idcross(i) + &
	        u_shck_irf(time+1,i,j)*m_shck_irf(time+1,age_t(time+1,i),j,k)
     ELSE
     ixcross(i) = (r+rk_t_irf(time+1,age_t(time,i)+1,j,k))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k))*&
		v_shck_irf(time+1,age_t(time+1,i),j,k)*n_shck_irf(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)))*idcross(i) + &
                u_shck_irf(time+1,i,j)*m_shck_irf(time+1,age_t(time+1,i),j,k)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_irf(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k)) + &
		(1.d0-delta(ideltacross(i)))*idcross(i)  + u_ret
     ELSE
     ixcross(i) = ( r+rk_t_irf(time+1,age_t(time,i)+1,j,k) )*( iapcross(i)-eta*idpcross(i) ) / &
		  gnodes(age_t(time+1,i),g_shck_irf(time+1,age_t(time+1,i),k)) + &
		  (1.d0-delta(ideltacross(i)))*idcross(i)  +  u_ret
     END IF

     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)

   ELSE
     IF ( init_x_irf(init_loc(i),i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_irf(init_loc(i),i,j) /r
     imcross(i) = init_x_irf(init_loc(i),i,j) / ( r*q_t_irf(time+1,1,j,k) )
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_irf(init_loc(i),i,j) )/(r+rk_t_irf(time+1,1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF

   ideltacross(i) = init_delta_irf(init_loc(i),i,j)
   idcross(i) =  init_d_irf(init_loc(i),i,j)/p_t_irf(time+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x_irf(init_loc(i),i,j)/p_t_irf(time+1,i,j,k) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + &
		u_shck_irf(time+1,i,j)*m_shck_irf(time+1,age_t(time+1,i),j,k)
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   IF (init_d_nadj_irf(init_loc(i),i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), g_shck_irf(time+1,age_t(time+1,i),k), rk_t_irf(time+1,1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)- &
	u_shck_irf(time+1,i,j)*m_shck_irf(time+1,age_t(time+1,i),j,k) )/(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + &
	 u_shck_irf(time+1,i,j)*m_shck_irf(time+1,age_t(time+1,i),j,k)
   END IF
   init_loc(i) = init_loc(i)+1

   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  END IF

	IF (time .EQ. ng-1) THEN
		 IF (k .EQ. 1) THEN
     ixcross0 = ixcross
	   idcross0 = idcross
	   ideltacross0 = ideltacross
     init_loc0 = init_loc

	   ikcross0 = ikcross
	   ibcross0 = ibcross
	   imcross0 = imcross
	   ELSE
     ixcross = ixcross0
	   idcross = idcross0
	   ideltacross = ideltacross0
     init_loc = init_loc0

	   ikcross = ikcross0
	   ibcross = ibcross0
	   imcross = imcross0
	   END IF
	END IF

  END DO time1

  END DO irf_c1
  END DO rep_irf1

  OPEN (UNIT=416, FILE="out/Irf_agg.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(416,*) cts, ';'
  WRITE(416,*) its, ';'
  WRITE(416,*) iexts, ';'
  WRITE(416,*) newcar, ';'
  WRITE(416,*) valnewcar, ';'
  WRITE(416,*) wts, ';'
	WRITE(416,*) val_cts, ';'
  CLOSE(416)

	OPEN (UNIT=442, FILE="out/Irf_coh.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(442,*) its_coh, ';'
  WRITE(442,*) sav_coh, ';'
  WRITE(442,*) inc_coh, ';'
	WRITE(442,*) valnewcar2_coh, ';'
	WRITE(442,*) adjust_coh, ';'
	WRITE(442,*) maintts_coh, ';'
  CLOSE(442)

END SUBROUTINE sub_irfsim
