SUBROUTINE sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,init_delta_shock,age_t,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,q_t_shock,rk_t_shock, &
	v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(shocklives,agents,rep), INTENT(IN) :: &
	 init_y_shock, init_x_shock, init_d_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(IN) :: init_d_nadj_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(IN) :: init_delta_shock
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(IN) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(IN) :: &
	n_shck_shock, dp_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(IN) :: u_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(IN) :: p_t_shock
  REAL(8), DIMENSION(numshock,ng,rep,shck_c), INTENT(IN) :: q_t_shock, w_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(IN) :: rk_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(IN) :: v_shck_shock, m_shck_shock
  INTEGER, DIMENSION(numshock,shck_c), INTENT(IN) :: g_shck_shock

  INTEGER :: time, time_i, i, i1, j, k
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	ibpcross, iycross, iynoadjcross, iwcross, imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, &
		ivalnewcar, isavecross, isavecross_r, iinccross, iwealthcross,  &
		icgrwcross, iloancross, ic_realcross_lag
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, iwork, isavshare, ideltacross
  REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: iexmat, valnewcarmat, dmat, cgrwmat, &
		wealthmat,  savemat, loanmat
  INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: agemat
  REAL(8), DIMENSION(numshock,rep,shck_c) :: cts, dts, its, iexts, newcar, valnewcar, kts, &
		bts, mts, sav, inc, wts, alive, cgrwts
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp
  INTEGER :: AllocateStatus
  CHARACTER(len=10) :: save_location

  ALLOCATE( valnewcarmat(shockseriesmat_n,agents_out,rep_out), &
		iexmat(shockseriesmat_n,agents_out,rep_out), &
		dmat(shockseriesmat_n,agents_out,rep_out), &
		savemat(shockseriesmat_n,agents_out,rep_out), &
		loanmat(shockseriesmat_n,agents_out,rep_out), &
		cgrwmat(shockseriesmat_n,agents_out,rep_out), &
		wealthmat(shockseriesmat_n,agents_out,rep_out),  STAT=AllocateStatus  )

	ALLOCATE( agemat(shockseriesmat_n,agents_out,rep_out),  STAT=AllocateStatus  )

  valnewcarmat=0.d0
  dmat=0.d0
  cgrwmat = 0.d0
	wealthmat=0.d0
  agemat=0
	savemat = 0.d0
  loanmat = 0.d0

  shck_c1: DO k=1, shck_c
  rep1: DO j = 1, rep
  time1: DO time = 1, numshock-1
  !$OMP PARALLEL
  !$OMP DO PRIVATE(u_temp)
   DO i = 1, agents
   IF (time==1) THEN
     IF (age_t(1,i)<=twork) THEN
     u_temp = u_shck_shock(1,i,j)*m_shck_shock(1,age_t(1,i),j,k)
     ELSE
     u_temp =  u_ret
     END IF
     IF ( init_x_shock(1,i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_shock(1,i,j) /r
     imcross(i) = init_x_shock(1,i,j) / (r*q_t_shock(1,age_t(1,i),j,k))
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(1,i,j) )/(r+rk_t_shock(1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF
   ideltacross(i) = init_delta_shock(1,i,j)
   idcross(i) = init_d_shock(1,i,j)/p_t_shock(1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x_shock(1,i,j)/p_t_shock(1,i,j,k) &
	 + (1.d0-delta(ideltacross(i)))*idcross(i) + u_temp
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   init_loc(i) = 2

   IF (init_d_nadj_shock(1,i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), g_shck_shock(1,k), rk_t_shock(1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)-u_temp)/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + u_temp
     END IF
   END IF
   END IF

   CALL sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), g_shck_shock(time,k), rk_t_shock(time,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )

   IF (alive_t_shock(time,i,j)==1) THEN
		 IF (  (age_t(time,i) .GT. 1) .AND. (ic_realcross(i)>0) .AND. (iccross(i)>0) ) THEN
     icgrwcross(i) = LOG( iccross(i) * p_t_shock(time,i,j,k) ) - LOG( ic_realcross(i) )
	   ELSE
		 icgrwcross(i) = 0.d0
		 END IF
     ic_realcross(i) = iccross(i) * p_t_shock(time,i,j,k)
     id_realcross(i) = idcross(i) * p_t_shock(time,i,j,k)
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t_shock(time,i,j,k)
       IF (adjcross(i)==2 .AND. &
			 idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t_shock(time,i,j,k)
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       END IF

       IF (adjcross(i)==2) THEN
			 iadjcross(i) = F * id_realcross(i)
			 ideltacross(i) = 2
       ELSE
			 iadjcross(i) = 0.d0
         IF ( dp_shck_shock(time,i,j) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF

       IF (age_t(time,i)<=twork) THEN
       u_temp = u_shck_shock(time,i,j)*m_shck_shock(time,age_t(time,i),j,k)
       ELSE
       u_temp =  u_ret
       END IF
       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       impcross(i) = ikpcross(i)/q_t_shock(time,age_t(time,i),j,k)
       ibpcross(i) = 0.d0
       isavshare(i) = 1
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_shock(time,i,j,k)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       isavshare(i) = 0
       END IF
    iwealthcross(i) =  r*q_t_shock(time,age_t(time,i),j,k)*imcross(i)-&
				(r+rk_t_shock(time,j,k))*ibcross(i)
    iloancross(i) = ibcross(i)

    IF (ikcross(i) .GE. 0) THEN
  	iinccross(i) = p_t_shock(time,i,j,k)*u_temp + (r-1.d0)*q_t_shock(time,age_t(time,i),j,k)*imcross(i)
		isavecross(i) = iinccross(i) - iicross(i) - iadjcross(i) - ic_realcross(i)
    isavecross_r(i) = (iicross(i) + iadjcross(i) + ic_realcross(i)) / iinccross(i)
    ELSE
		iinccross(i) = p_t_shock(time,i,j,k)*u_temp
		isavecross(i) = iinccross(i) - (r+rk_t_shock(time,j,k)-1.d0)*ibcross(i) &
				- iicross(i) - iadjcross(i) - ic_realcross(i)
    isavecross_r(i) = (iicross(i) + iadjcross(i) + ic_realcross(i) &
	 						+ (r+rk_t_shock(time,j,k)-1.d0)*ibcross(i) ) / iinccross(i)
    END IF

		IF(age_t(time,i)<=twork) THEN
		iwork(i) = 1
		iwcross(i) = p_t_shock(time,i,j,k) * u_shck_shock(time,i,j) * m_shck_shock(time,age_t(time,i),j,k)
		ELSE
		iwork(i) = 0
		iwcross(i)=0.d0
		END IF

   ELSE
   ic_realcross(i)=0.d0
	 icgrwcross(i) = 0.d0
   id_realcross(i)=0.d0
   iicross(i)=0.d0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
	 iadjcross(i) = 0.d0
   ikcross(i)=0.d0
   ikpcross(i) = 0.d0
   ibcross(i)=0.d0
	 ibpcross(i)=0.d0
	 iloancross(i)=0.d0
   imcross(i)=0.d0
	 iwealthcross(i)=0.d0
   isavshare(i) = 0
   iinccross(i) = 0.d0
   isavecross_r(i) = 0.d0
	 iwork(i)=0
	 iwcross(i)=0.d0
   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

	alive(time,j,k) = SUM(DBLE(alive_t_shock(time,:,j)))
  cts(time,j,k)   = SUM( ic_realcross ) / alive(time,j,k)
	cgrwts(time,j,k)   = SUM( icgrwcross ) / (alive(time,j,k)-agent_age)
  dts(time,j,k) = SUM( id_realcross ) / alive(time,j,k)
  its(time,j,k)   = SUM( iicross ) / alive(time,j,k)
  iexts(time,j,k) = SUM( ivalnewcar ) / alive(time,j,k)
  newcar(time,j,k) = SUM( DBLE(inewcar) )/ alive(time,j,k)
  IF (  SUM( DBLE(inewcar) ) >0.5d0 ) THEN
  valnewcar(time,j,k) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  ELSE
  valnewcar(time,j,k) = 0.d0
  END IF
  kts(time,j,k) = SUM( ikcross ) / alive(time,j,k)
  bts(time,j,k) = SUM( ibcross ) / alive(time,j,k)
  mts(time,j,k) = SUM( imcross ) / alive(time,j,k)
  sav(time,j,k)   = SUM( isavecross ) / alive(time,j,k)
  inc(time,j,k)   = SUM( iinccross ) / alive(time,j,k)
  wts(time,j,k)   = SUM(iwcross ) / SUM( DBLE(iwork) )

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)))*idcross(i) + &
	        u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     ELSE
     ixcross(i) = (r+rk_t_shock(time+1,j,k))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes(age_t(time+1,i),g_shck_shock(time+1,k))*&
		v_shck_shock(time+1,age_t(time+1,i),j,k)*n_shck_shock(time+1,i,j)) &
		+ (1.d0-delta(ideltacross(i)))*idcross(i) + &
                u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i),g_shck_shock(time+1,k))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_shock(time+1,age_t(time+1,i),j,k) * r * (iapcross(i)-eta*idpcross(i)) / &
		gnodes(age_t(time+1,i),g_shck_shock(time+1,k)) + &
		(1.d0-delta(ideltacross(i)))*idcross(i)  + u_ret
     ELSE
     ixcross(i) = ( r+rk_t_shock(time+1,j,k) )*( iapcross(i)-eta*idpcross(i) ) / &
		  gnodes(age_t(time+1,i),g_shck_shock(time+1,k)) + &
		  (1.d0-delta(ideltacross(i)))*idcross(i)  +  u_ret
     END IF

     END IF
		 ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)

   ELSE
     IF ( init_x_shock(init_loc(i),i,j) >= 0.d0 ) THEN
     ikcross(i) = init_x_shock(init_loc(i),i,j) /r
     imcross(i) = init_x_shock(init_loc(i),i,j) / ( r*q_t_shock(time+1,1,j,k) )
     ibcross(i) = 0.d0
     ELSE
     ibcross(i) = ABS( init_x_shock(init_loc(i),i,j) )/(r+rk_t_shock(time+1,j,k))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF

   ideltacross(i) = init_delta_shock(init_loc(i),i,j)
   idcross(i) =  init_d_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x_shock(init_loc(i),i,j)/p_t_shock(time+1,i,j,k) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + &
		u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   IF (init_d_nadj_shock(init_loc(i),i,j)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), g_shck_shock(time+1,k), rk_t_shock(time+1,j,k), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)- &
			u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k) )/(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + &
	 		u_shck_shock(time+1,i,j)*m_shck_shock(time+1,age_t(time+1,i),j,k)
   END IF
   init_loc(i) = init_loc(i)+1

   END IF

   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  IF (k==1) THEN
  IF (j<=rep_out) THEN
  !$OMP PARALLEL
  !$OMP DO PRIVATE(i1,time_i)
   DO i = 1, agents_out
   i1 = (i-1)*agents_out_sc + 1
      IF (time>=numshock-shockseriesmat_n .AND. time<numshock) THEN
      time_i = time - (numshock-shockseriesmat_n-1)
       IF (alive_t_shock(time,i1,j)==1) THEN
			 agemat(time_i,i,j) = age_t(time,i1)
			 	 IF ( agemat(time_i,i,j)>1 .AND. &
			 		ic_realcross(i1)>0 .AND. ic_realcross_lag(i1)>0 ) THEN
           cgrwmat(time_i,i,j) = LOG( ic_realcross(i1) ) - LOG( ic_realcross_lag(i1) )
         ELSE
           cgrwmat(time_i,i,j) = -123.d0
         END IF
       iexmat(time_i,i,j) = ivalnewcar(i1)
       savemat(time_i,i,j) = isavecross_r(i1)
			 loanmat(time_i,i,j) = ibpcross(i1)
			 wealthmat(time_i,i,j) = iwealthcross(i1)
       IF (inewcar(i1)==1) THEN
       valnewcarmat(time_i,i,j) = ivalnewcar(i1)
       ELSE
       valnewcarmat(time_i,i,j) = -123.d0
       END IF
       dmat(time_i,i,j) = id_realcross(i1)
       ELSE
       agemat(time_i,i,j) = -1
       END IF
      END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL
  END IF
  END IF

	!$OMP PARALLEL
  !$OMP DO
  DO i = 1, agents
	ic_realcross_lag(i) = ic_realcross(i)
	END DO
	!$OMP END DO
	!$OMP END PARALLEL

  END DO time1
  END DO rep1
  END DO shck_c1

	IF ( (base_rate .EQV. .TRUE.) .AND. (base_growth .EQV. .TRUE.) ) THEN
	save_location = 'growth'
	ELSEIF ( base_rate .EQV. .TRUE. ) THEN
	save_location = 'rate'
	ELSE
	save_location = 'price'
	END IF

  OPEN (UNIT=420, FILE="out/Shocksimulate"//trim(save_location)//".txt",ACTION="WRITE", POSITION="REWIND")
  WRITE(420,*) cts, ';'
	WRITE(420,*) cgrwts, ';'
  WRITE(420,*) its, ';'
  WRITE(420,*) newcar, ';'
  WRITE(420,*) valnewcar, ';'
  WRITE(420,*) bts, ';'
  WRITE(420,*) sav, ';'
  WRITE(420,*) inc, ';'
	WRITE(420,*) wts, ';'
  CLOSE(420)

	IF ( (base_rate .EQV. .TRUE.) .AND. (base_growth .EQV. .TRUE.) ) THEN
  save_location = 'growth'
  ELSEIF ( base_rate .EQV. .TRUE.) THEN
  save_location = 'rate'
  ELSE
  save_location = 'price'
	END IF

	OPEN(UNIT=379, FILE="out/model_spec", ACTION="WRITE", POSITION="REWIND")
	WRITE(379,*) save_location
	CLOSE(379)

	OPEN (UNIT=228, FILE='out/Shockmat.txt', ACTION="WRITE", POSITION="REWIND")
	!OPEN (UNIT=228, FILE='/PATH/full_model/out/Shockmat.txt', &
	ACTION="WRITE", POSITION="REWIND")
	WRITE(228,*) cgrwmat, ';'
  WRITE(228,*) iexmat, ';'
  WRITE(228,*) valnewcarmat, ';'
  WRITE(228,*) dmat, ';'
	WRITE(228,*) wealthmat, ';'
  WRITE(228,*) savemat, ';'
	WRITE(228,*) loanmat, ';'
  WRITE(228,*) agemat, ';'
  CLOSE(228)

	  DEALLOCATE( valnewcarmat, iexmat, dmat, savemat, cgrwmat, wealthmat, agemat, &
		 	loanmat)





END SUBROUTINE sub_shocksim
