SUBROUTINE sub_simulate(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y,init_x,init_d,init_d_nadj,init_delta,age_t,alive_t, &
	n_shck,u_shck,p_t,dp_shck,q_t,rk_t,v_shck,w_shck)
USE OMP_LIB
USE share
IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(simlives,agents), INTENT(IN) :: init_y, init_x, init_d
  INTEGER, DIMENSION(simlives,agents), INTENT(IN) :: init_d_nadj
  INTEGER, DIMENSION(simlives,agents), INTENT(IN) :: init_delta
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t, alive_t
  REAL(8), DIMENSION(numsim,agents), INTENT(IN) :: n_shck, u_shck, p_t, dp_shck
  REAL(8), DIMENSION(numsim,ng), INTENT(IN) :: q_t, w_shck
  REAL(8), DIMENSION(numsim), INTENT(IN) ::  rk_t, v_shck
  INTEGER :: time, i, j
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
	 ibpcross, iycross, iynoadjcross, iwcross, imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ild_realcross, &
	 ivalnewcar, id_new_realcross, iq_tcross
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, isavshare, ideltacross

  REAL(8), DIMENSION(numsim) :: cts, dts, ldts, its, iexts, newcar, valnewcar, &
	 sav20, istd_logd, d_newts
  REAL(8), DIMENSION(numsim-burnin) :: cts_hp, its_hp, yts_hp, ynoadjts_hp, wts_hp, val_hp
  REAL(8) :: mean_c, mean_id, mean_buycar, mean_idex_c, &
  	mean_sav20, mean_val_d_new, mean_istd_logd,  &
	mean_c_hp, mean_id_hp, mean_val_hp, &
	std_c, std_id, std_val, &
	cov_idc, corr_idc
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: u_temp

  !$OMP PARALLEL DO PRIVATE(u_temp)
  DO i=1,agents
    IF (age_t(1,i)<=twork) THEN
    u_temp = u_shck(1,i)
    ELSE
    u_temp = u_ret
    END IF
    IF ( init_x(1,i) >= 0.d0 ) THEN
    ikcross(i) = ( init_x(1,i) )/r
    imcross(i) = init_x(1,i)/ (q_t(1,age_t(1,i)) * r)
    ibcross(i) = 0.d0
    ELSE
    ibcross(i) = ABS( init_x(1,i) ) /(r+rk_t(1))
    ikcross(i) = 0.d0
    imcross(i) = 0.d0
    END IF

   ideltacross(i) = init_delta(1,i)
   idcross(i) = init_d(1,i)/p_t(1,i)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) = init_x(1,i) /p_t(1,i) + &
	(1.d0-delta(ideltacross(i)))*idcross(i) + u_temp
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)
   init_loc(i) = 2

   IF (init_d_nadj(1,i)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(1,i), ideltacross(i), gnorm, rk_t(1),  &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)-u_temp)/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + u_temp
     END IF
   END IF
  END DO
  !$OMP END PARALLEL DO

  time1: DO time = 1, numsim-1
  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age_t(time,i), ideltacross(i), gnorm, rk_t(time), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )

   IF (alive_t(time,i)==1) THEN
     ic_realcross(i) = iccross(i) * p_t(time,i)
     id_realcross(i) = idcross(i) * p_t(time,i)
     ild_realcross(i) = LOG( MAX(id_realcross(i),1d-6) )
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t(time,i)
       IF (adjcross(i)==2 .AND. &
		   idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t(time,i)
       id_new_realcross(i) = id_realcross(i)
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       id_new_realcross(i) = 0.d0
       END IF

       IF (adjcross(i)==2) THEN
       ideltacross(i) = 2
       ELSE
         IF ( dp_shck(time,i) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF

       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t(time,i)
       impcross(i) = ikpcross(i)/q_t(time,age_t(time,i) )
       ibpcross(i) = 0.d0
       isavshare(i) = 1
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t(time,i)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       isavshare(i) = 0
       END IF


   ELSE
   ic_realcross(i)=0.d0
   id_realcross(i)=0.d0
   ild_realcross(i)=0.d0
   iicross(i)=0.d0
   inewcar(i)=0
   ivalnewcar(i)=0.d0
   id_new_realcross(i) = 0.d0
   ikpcross(i) = 0.d0
   ikcross(i)=0.d0
   imcross(i)=0.d0
   ibcross(i)=0.d0
   isavshare(i) = 0
   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  cts(time)   = SUM( ic_realcross ) / SUM(DBLE(alive_t(time,:)))
  dts(time) = SUM( id_realcross ) / SUM(DBLE(alive_t(time,:)))
  ldts(time)   = SUM( ild_realcross ) / SUM(DBLE(alive_t(time,:)))
  its(time)   = SUM( iicross ) / SUM(DBLE(alive_t(time,:)))
  iexts(time) = SUM( ivalnewcar ) / SUM(DBLE(alive_t(time,:)))
  newcar(time) = SUM( DBLE(inewcar) )/ SUM(DBLE(alive_t(time,:)))
  valnewcar(time) = SUM( ivalnewcar ) / SUM( DBLE(inewcar) )
  d_newts(time) = SUM( id_new_realcross ) / SUM( DBLE(inewcar) )
  sav20(time)   = SUM( DBLE(isavshare), MASK= age_t(time,:) .LE. 20 ) / &
	SUM(DBLE(alive_t(time,:)), MASK= age_t(time,:) .LE. 20 )

  istd_logd(time) = 0.d0
  DO i = 1, agents
    IF (alive_t(time,i)==1) THEN
    istd_logd(time) = istd_logd(time) + ( ild_realcross(i) - ldts(time) )**2
    END IF
  END DO
  istd_logd(time) = SQRT( istd_logd(time) / (SUM(DBLE(alive_t(time,:)))-1.d0) )

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age_t(time,i)<ng) THEN
     IF(age_t(time,i)<twork) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes(age_t(time+1,i),gnorm)*v_shck(time+1)*n_shck(time+1,i))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * w_shck(time+1,age_t(time+1,i)) * ( iapcross(i)-eta*idpcross(i) )   / &
		(gnodes(age_t(time+1,i),gnorm)*v_shck(time+1)*n_shck(time+1,i)) + &
		 (1.d0-delta(ideltacross(i)))*idcross(i) + u_shck(time+1,i)
     ELSE
     ixcross(i) = (r+rk_t(time+1))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes(age_t(time+1,i),gnorm)*v_shck(time+1)*n_shck(time+1,i)) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + u_shck(time+1,i)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes(age_t(time+1,i),gnorm)
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = r * w_shck(time+1,age_t(time+1,i)) * ( iapcross(i)-eta*idpcross(i) )   / &
		 gnodes(age_t(time+1,i),gnorm) + &
		 (1.d0-delta(ideltacross(i)))*idcross(i) + u_ret
     ELSE
     ixcross(i) = (r+rk_t(time+1))*(iapcross(i)-eta*idpcross(i)) / &
		   gnodes(age_t(time+1,i),gnorm) + &
		  (1.d0-delta(ideltacross(i)))*idcross(i) + u_ret
     END IF

     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)
   ELSE
     IF ( init_x(init_loc(i),i)>= 0.d0 ) THEN
     ikcross(i) = ( init_x(init_loc(i),i) )/r
     ibcross(i) = 0.d0
     imcross(i) = init_x(init_loc(i),i)/(r*q_t(time+1,1))
     ELSE
     ibcross(i) = ABS( init_x(init_loc(i),i) )/(r+rk_t(time+1))
     ikcross(i) = 0.d0
     imcross(i) = 0.d0
     END IF

   ideltacross(i) = init_delta(init_loc(i),i)
   idcross(i) =  init_d(init_loc(i),i)/p_t(time+1,i)
   idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
   ixcross(i) =  init_x(init_loc(i),i)/p_t(time+1,i) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + u_shck(time+1,i)
   ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)

   IF (init_d_nadj(init_loc(i),i)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), gnorm,  rk_t(time+1),&
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
   END IF
   IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)-u_shck(time+1,i))/(r+rk)<-eta*idcross(i) ) THEN
   ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i)+ u_shck(time+1,i)
   END IF
   init_loc(i) = init_loc(i)+1

   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


  END DO time1

  mean_buycar = 100.d0*SUM ( newcar(burnin:numsim-1) )/ (numsim-burnin)
  mean_idex_c = SUM ( iexts(burnin:numsim-1)/cts(burnin:numsim-1) )/ (numsim-burnin)
  mean_istd_logd = 100.d0 * SUM ( istd_logd(burnin:numsim-1) )/ (numsim-burnin)
  mean_val_d_new = SUM( valnewcar(burnin:numsim-1)/d_newts(burnin:numsim-1) )/ (numsim-burnin)
  mean_sav20 = 100.d0*SUM ( sav20(burnin:numsim-1) )/ (numsim-burnin)

  CALL SUB_HPFILT(LOG(cts(burnin:numsim-1)),cts_hp,numsim-burnin,6.25d0,0)
  CALL SUB_HPFILT(LOG(its(burnin:numsim-1)),its_hp,numsim-burnin,6.25d0,0)
  CALL SUB_HPFILT(LOG(valnewcar(burnin:numsim-1)),val_hp,numsim-burnin,6.25d0,0)
  mean_c_hp = SUM ( cts_hp )/ (numsim-burnin)
  mean_id_hp = SUM ( its_hp )/ (numsim-burnin)
  mean_val_hp = SUM ( val_hp )/ (numsim-burnin)

  std_c = 0.d0
  std_id = 0.d0
  std_val = 0.d0
  cov_idc = 0.d0

  DO time=1,numsim-burnin
  std_c = std_c + ( cts_hp(time) - mean_c_hp )**2
  std_id = std_id + ( its_hp(time) - mean_id_hp )**2
  std_val = std_val + ( val_hp(time) - mean_val_hp )**2
  cov_idc = cov_idc + ( its_hp(time) - mean_id_hp )*( cts_hp(time) - mean_c_hp )
  END DO

  corr_idc = cov_idc / ( SQRT(std_id)*SQRT(std_c) )
  std_c = 100.d0*SQRT( std_c / (numsim-burnin-1.d0) )
  std_id = 100.d0*SQRT( std_id / (numsim-burnin-1.d0) )
  std_val = 100.d0*SQRT( std_val / (numsim-burnin-1.d0) )

  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) '  '
  WRITE(555,*) ' SIMULATION MOMENTS '
	WRITE(555,*) '                     									 model                 (data) '
  WRITE(555,*) ' ------------------ '
	  WRITE(555,*) ' Mean % buy car:                  ', mean_buycar, ' (19.1) '
  WRITE(555,*) ' Mean car spend:non-durables:       ', mean_idex_c, ' (0.099) '
  WRITE(555,*) ' Mean car purchase:stock | buy:     ', mean_val_d_new, ' (0.833) '
	WRITE(555,*) ' Percent without loan (under 25):   ', mean_sav20, ' (55.5) '
  WRITE(555,*) ' St. dev non-durables:              ', std_c, ' (0.77) '
  WRITE(555,*) ' St. dev car investment:            ', std_id, ' (5.91) '
  WRITE(555,*) ' St. dev car intensive margin:      ', std_val, ' (2.69) '
  WRITE(555,*) ' Corr. (non-dur,car inv):           ', corr_idc, ' (0.72) '
	WRITE(555,*) '  '
	WRITE(555,*) ' Cross section std of car stock:    ', mean_istd_logd, ' (94.7) '
  CLOSE(555)


END SUBROUTINE sub_simulate
